// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: ejb/SpringSessionLocal.vsl in andromda-spring-cartridge.
//
package org.andromda.samples.carrental.customers.ejb;

import java.util.Collection;
import javax.ejb.EJBLocalObject;
import org.andromda.samples.carrental.customers.CustomerException;
import org.andromda.samples.carrental.customers.DriverData;

/**
 * @see org.andromda.samples.carrental.customers.CustomerService
 */
public interface CustomerService
    extends EJBLocalObject
{
    /**
     * <p>
     * Creates a new customer.
     * </p>
     * <p>
     * @param name name of the new customer
     * </p>
     * <p>
     * @param customerNo customer number of the new customer
     * </p>
     * <p>
     * @return String with the customer id
     * </p>
     * @param name 
     * @param customerNo 
     * @param password 
     * @return String
     * @throws CustomerException
     */
    public String createCustomer(String name, String customerNo, String password)
        throws CustomerException;

    /**
     * <p>
     * Adds a licensed driver to the drivers associated with a
     * particular customer.
     * </p>
     * <p>
     * @param customerId the id of the Customer object
     * </p>
     * <p>
     * @param driverData the data for the Driver to be created
     * </p>
     * <p>
     * @return a String with the Driver object's id
     * </p>
     * @param customerId 
     * @param driverData 
     * @return String
     * @throws CustomerException
     */
    public String addDriver(String customerId, DriverData driverData)
        throws CustomerException;

    /**
     * <p>
     * Searches all customers.
     * </p>
     * <p>
     * @return a Collection with CustomerData objects.
     * </p>
     * @return Collection
     * @throws CustomerException
     */
    public Collection searchAllCustomers()
        throws CustomerException;

    /**
     * <p>
     * Authenticates a user as a customer.
     * </p>
     * <p>
     * @return a String with the id of the Customer object.
     * </p>
     * <p>
     * @param customerNo the customer number
     * </p>
     * <p>
     * @param password the customer's password
     * </p>
     * @param customerNo 
     * @param password 
     * @return String
     * @throws CustomerException
     */
    public String authenticateAsCustomer(String customerNo, String password)
        throws CustomerException;

}